﻿using System;
using System.ComponentModel;
using System.Web.UI.WebControls.WebParts;

using ERPConnectServices;
namespace PurchaseOrderSample.CreatePurchaseOrder
{
    [ToolboxItemAttribute(false)]
    public partial class CreatePurchaseOrder : WebPart
    {
        // Uncomment the following SecurityPermission attribute only when doing Performance Profiling on a farm solution
        // using the Instrumentation method, and then remove the SecurityPermission attribute when the code is ready
        // for production. Because the SecurityPermission attribute bypasses the security check for callers of
        // your constructor, it's not recommended for production purposes.
        // [System.Security.Permissions.SecurityPermission(System.Security.Permissions.SecurityAction.Assert, UnmanagedCode = true)]
        public CreatePurchaseOrder()
        {
        }

        protected override void OnInit(EventArgs e)
        {
            base.OnInit(e);
            InitializeControl();
        }

        protected void Page_Load(object sender, EventArgs e)
        {
        }

        protected void btn_CreatePO_Click(object sender, EventArgs e)
        {
            using (ERPConnectServiceClient client = new ERPConnectServiceClient())
            {
                // Create a RFC-Function object
                ERPFunction func = client.CreateFunction("BAPI_PO_CREATE");

                // Fill header structure
                ERPStructure Header = func.Exports["PO_HEADER"].ToStructure();
                Header["DOC_TYPE"] = "NB";
                Header["PURCH_ORG"] = "1000";
                Header["PUR_GROUP"] = "010";
                // check for date & time format strings  http://msdn.microsoft.com/en-us/library/8kb3ddd4.aspx
                Header["DOC_DATE"] = DateTime.Now.ToString("yyyyMMdd");
                Header["VENDOR"] = tb_Vendor.Text;

                // Create an Item
                ERPTable items = func.Tables["PO_ITEMS"];
                ERPStructure item = items.AddRow();
                item["PO_ITEM"] = "1";
                item["PUR_MAT"] = tb_Material.Text;
                item["PLANT"] = tb_Plant.Text;

                // Create and fill shedules
                ERPTable shedules = func.Tables["PO_ITEM_SCHEDULES"];
                ERPStructure shedule = shedules.AddRow();
                shedule["PO_ITEM"] = "1";
                shedule["DELIV_DATE"] = DateTime.Now.ToString("yyyyMMdd");
                shedule["QUANTITY"] = Convert.ToDecimal(tb_Quantity.Text);

                // Exceute Bapi and process return messages
                func.Execute();
                lbl_Message.Text = "";
                lbl_Message.Text += func.Tables["RETURN"].Rows[0, "MESSAGE"] + "\r\n";
            }
        }
    }
}
